import random
import discord
from discord import app_commands
from discord.ui import Select, View

# クライアント接続オブジェクト
intents = discord.Intents.default()
intents.message_content = True
intents.members = True
client = discord.Client(intents=intents)
tree = app_commands.CommandTree(client)

messagelist = ['こんにちは', '元気ですか？', 'どうしました？', '最近何して遊びました？']


# Botの起動とDiscordサーバーへの接続
@client.event
async def on_ready():
    # コマンドをDiscordに登録
    await tree.sync()
    print(f'We have logged in as {client.user}')


# コマンドの定義
@tree.command(name="test", description="テストコマンドです。打ち込んだ文字が表示されます")
async def test_command(interaction: discord.Interaction, string: str):
    await interaction.response.send_message(f"Hello, {string}!")


@tree.command(name="members", description="現在サーバーにいるメンバーを表示します")
async def members_command(interaction: discord.Interaction):
    members = []
    async for member in interaction.guild.fetch_members(limit=150):
        members.append(member)
    for member in members:
        await interaction.response.send_message(member.name)


@tree.command(name="add_message", description="Botが返信するメッセージを追加します")
async def add_message_command(interaction: discord.Interaction, message: str):
    await addmessage(message)
    await interaction.response.send_message(f"{message}を追加しました")


@tree.command(name="show", description="Botが返信するメッセージを表示します")
async def show_command(interaction: discord.Interaction):
    await interaction.response.send_message(messagelist)


# メッセージ受信時に動作する処理
@client.event
async def on_message(message):
    # メッセージ送信者がBotだった場合は無視する
    if message.author.bot:
        return
    if client.user in message.mentions:  # 話しかけられたかの判定
        await reply(message)  # 返信する非同期関数を実行
    if message.content.startswith('Botちゃんやんないほうがいいよね？'):
        await message.channel.send('う、うん...やっぱやんないほうがいいかも...')


# じゃんけんコマンドの定義
@tree.command(name="janken", description="Botが返信するメッセージを表示します")
async def somemenu(interaction: discord.Interaction):
    view = SelectView()
    view.selectMenu.add_option(label="グー", value='グー', description="グーを選択します")
    view.selectMenu.add_option(label="チョキ", value='チョキ', description="チョキを選択します")
    view.selectMenu.add_option(label="パー", value='パー', description="パーを選択します")
    await interaction.response.send_message("自分の手を選んでね", view=view)


# メッセージの受信時に動作する処理
class SelectView(View):
    @discord.ui.select(
        cls=Select,
        placeholder="じゃんけんの手札",
    )
    async def selectMenu(self, interaction: discord.Interaction, select: Select):
        # 選択後に選択肢を無効化
        select.disabled = True
        # 選択した手札を取得
        select_hand=select.values[0]
        # 選択肢のセレクトメニューの表示を更新
        select.placeholder = f"あなたは{select_hand}を選択済みです"
        # メッセージを更新
        await interaction.response.edit_message(content=select_hand, view=self)
        hands = ["グー", "チョキ", "パー"]
        hand = random.choice(hands)
        if select_hand == hand:
            return await interaction.followup.send(f'私は{hand}を出しました。あいこです。')
        elif (select_hand == 'グー' and hand == 'パー') or (select_hand == 'チョキ' and hand == 'グー') or (
                select_hand == 'パー' and hand == 'チョキ'):
            return await interaction.followup.send(f'私は{hand}を出しました。私の勝ちです。')
        else:
            return await interaction.followup.send(f'私は{hand}を出しました。あなたの勝ちです。')

# 判定コマンドの定義
@tree.command(name="hantei", description="Botが返信するメッセージをやるべきか判定してくれます")
async def show_command(interaction: discord.Interaction):
    hands = ["やると良いと思うよ！",
             "やめといたほうがいいかも…"]
    hand = random.choice(hands)
    await interaction.response.send_message(hand)



# 返信する非同期関数を定義
async def reply(message):
    num = len(messagelist)
    randomlen = random.randint(0, num - 1)
    reply = f'{message.author.mention} {messagelist[randomlen]}'  # 返信メッセージの作成
    await message.channel.send(reply)  # 返信メッセージを送信


async def addmessage(message: str):
    messagelist.append(message)


# コマンドに対応するリストデータを取得する関数を定義
def get_data(message):
    command = message.content
    data_table = {
        '/members': message.guild.members,  # メンバーのリスト
        '/roles': message.guild.roles,  # 役職のリスト
        '/text_channels': message.guild.text_channels,  # テキストチャンネルのリスト
        '/voice_channels': message.guild.voice_channels,  # ボイスチャンネルのリスト
        '/category_channels': message.guild.categories,  # カテゴリチャンネルのリスト
    }
    return data_table.get(command, '無効なコマンドです')


client.run('MTIwNDM4MjYzMTk2MjIxODUwNg.GK5o7u.EchMHxs5gB9Mud3cQqqevk_honxOXNcfjsJneg')
